﻿Type=Activity
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

'Choose Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private spnCountryEnabled As Boolean
	spnCountryEnabled = False
	Private spnCentreEnabled As Boolean
	spnCentreEnabled = False
	Private spnLocationEnabled As Boolean
	spnLocationEnabled = False
	Private btnMapEnabled As Boolean
	btnMapEnabled = False
	Private btnViewEnabled As Boolean
	btnViewEnabled = False
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim lblCountry As Label
	Dim spnCountry As Spinner
	Dim spnCountryId As Spinner
	Dim lblCentre As Label
	Dim spnCentre As Spinner
	Dim spnCentreId As Spinner
	Dim lblLocation As Label
	Dim spnLocation As Spinner
	Dim spnLocationId As Spinner
	Dim btnMap As Button
	Dim btnView As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	If Main.test_1 <> Main.secret Then
		Log("No hacking allowed")
		Log("test_1="&Main.test_1)
		Msgbox("No hacking allowed.", "Closing application")	
		ExitApplication
	End If
	Activity.LoadLayout("Choose") 'Load the Choose layout file.
  ResizeViews
	spnCountry.Enabled = False
	spnCentre.Enabled = False
	spnLocation.Enabled = False
	btnMap.Enabled = False
	btnView.Enabled = False
	spnCountryEnabled = False
	spnCentreEnabled = False
	spnLocationEnabled = False
	btnMapEnabled = False
	btnViewEnabled = False
	DoEvents
	PopulateCountry
End Sub

Sub Activity_Resume
  If Main.Country = "" Then
		PopulateCountry
	Else
		spnCountry.SelectedIndex = spnCountry.Indexof(Main.Country)
		spnCountryId.SelectedIndex = spnCountry.Indexof(Main.Country)
		If Main.Centre = "" Then
			PopulateCentre
		Else
			spnCentre.SelectedIndex = spnCentre.Indexof(Main.Centre)
			spnCentreId.SelectedIndex = spnCentre.Indexof(Main.Centre)
			If Main.Location = "" Then
				PopulateLocation
			Else
				spnLocation.SelectedIndex = spnLocation.Indexof(Main.Location)
				spnLocationId.SelectedIndex = spnLocation.Indexof(Main.Location)
			End If
		End If
	End If
	If spnCountryEnabled Then
		spnCountry.Enabled = True
	Else
	  spnCountry.Enabled =False
	End If
	If spnCentreEnabled Then
		spnCentre.Enabled = True
	Else
	  spnCentre.Enabled =False
	End If
	If spnLocationEnabled Then
		spnLocation.Enabled = True
	Else
	  spnLocation.Enabled =False
	End If	
	If btnMapEnabled Then
		btnMap.Enabled = True
	Else
	  btnMap.Enabled =False
	End If
	If btnViewEnabled Then
		btnView.Enabled = True
	Else
	  btnView.Enabled =False
	End If
	DoEvents
	ResizeViews
End Sub

Sub Activity_Pause (UserClosed As Boolean)
  If spnCountry.SelectedIndex > 0 Then
		Main.Country = spnCountry.SelectedItem
		Main.CountryId = spnCountryId.SelectedItem
		If spnCentre.SelectedIndex > 0 Then
			Main.Centre = spnCentre.SelectedItem
			Main.CentreId = spnCentreId.SelectedItem
			If spnLocation.SelectedIndex > 0 Then
				Main.Location = spnLocation.SelectedItem
				Main.LocationId = spnLocationId.SelectedItem 
			Else
	  		Main.Location = ""
				Main.LocationId = 0
			End If
		Else
	  	Main.Centre = ""
			Main.CentreId = 0
			Main.Location = ""
			Main.LocationId = 0
		End If
	Else
	  Main.Country = ""
		Main.CountryId = 0
		Main.Centre = ""
		Main.CentreId = 0
		Main.Location = ""
		Main.LocationId = 0
	End If
	Main.Aspect = ""
	Main.AspectId = 0
	If btnMap.Enabled Then
		btnMapEnabled = True
	Else
	  btnMapEnabled =False
	End If
	If btnView.Enabled Then
		btnViewEnabled = True
	Else
	  btnViewEnabled =False
	End If
End Sub

Sub spnCountry_ItemClick (Position As Int, Value As Object)
  Dim spnIndex As Int
	If spnCountry.Size = 2 Then
		spnCountry.SelectedIndex = 1
	End If
	Main.Country = spnCountry.SelectedItem
	spnIndex = spnCountry.SelectedIndex
	spnCountryId.SelectedIndex = spnIndex
	Main.CountryId = spnCountryId.GetItem(spnIndex)
	spnCentre.Clear
	spnCentreId.Clear
	spnCentre.Enabled = False
	spnCentreEnabled = False
	Main.Centre = ""
	Main.CentreId = 0
	spnLocation.Clear
	spnLocationId.Clear
	spnLocation.Enabled = False
	spnLocationEnabled = False
	btnMapEnabled = False
	btnViewEnabled = False
	btnMap.Enabled = False
	btnView.Enabled = False
	DoEvents
	Main.Location = ""
	Main.LocationId = 0
	Main.Aspect = ""
	Main.AspectId = 0
	If spnIndex > 0 Then
 	  PopulateCentre
	End If
End Sub

Sub spnCentre_ItemClick (Position As Int, Value As Object)
  Dim spnIndex As Int
	If spnCentre.Size = 2 Then
		spnCentre.SelectedIndex = 1
	End If
	Main.Centre = spnCentre.SelectedItem
	spnIndex = spnCentre.SelectedIndex
	spnCentreId.SelectedIndex = spnIndex
	Main.CentreId = spnCentreId.GetItem(spnIndex)	
	spnLocation.Clear
	spnLocationId.Clear
	spnLocation.Enabled = False
	spnLocationEnabled = False
	btnMapEnabled = False
	btnViewEnabled = False
	btnMap.Enabled = False
	btnView.Enabled = False
	DoEvents
	Main.Location = ""
	Main.LocationId = 0
	Main.Aspect = ""
	Main.AspectId = 0
	If spnIndex > 0 Then
		PopulateLocation
	End If
End Sub

Sub spnLocation_ItemClick (Position As Int, Value As Object)
	Dim spnIndex As Int
	If spnLocation.Size = 2 Then
		spnLocation.SelectedIndex = 1
	End If
	Main.Location = spnLocation.SelectedItem
	spnIndex = spnLocation.SelectedIndex
	spnLocationId.SelectedIndex = spnIndex
	Main.LocationId = spnLocationId.GetItem(spnIndex)
	If spnIndex = 0 Then
		Main.Aspect = ""
		Main.AspectId = 0
		btnMapEnabled = False
		btnViewEnabled = False
		btnMap.Enabled = False
		btnView.Enabled = False
		DoEvents
		Return
	End If
	btnMap.Enabled = True
	btnView.Enabled = True
	btnMapEnabled = True
	btnViewEnabled = True
	btnView.RequestFocus
	DoEvents
End Sub

Sub btnMap_Click
	Dim ph As Phone
	Dim myLAN As ServerSocket
	If ph.GetDataState <> "CONNECTED" _
	AND myLAN.GetMyIP = "127.0.0.1" Then
		Msgbox("Ensure that your Device" & CRLF & _
	  	     "is Data Connected by Phone" & CRLF & _
	    	   "or is WiFi Connected." & CRLF & _
	  			 "And then try again.", _
		  	 	 "No Internet Connection")
		Return
	End If
	Dim query As String
	Dim CursorAverage As Cursor
	query = "SELECT Latitude, Longitude " & _
	        "FROM Aspect " & _
	        "WHERE LocationId = " & Main.LocationId & " " & _
					"ORDER BY Id"
	CursorAverage = Main.SQL1.ExecQuery(query)
	If CursorAverage.RowCount = 0 Then
		Msgbox("No Aspect available for Location " & Main.Location & ":" & CRLF & _
		       "Select another Location.", _
		       "Location selected")
		Return
	End If
	Dim NumberOfAspects
	NumberOfAspects = CursorAverage.RowCount
	Dim SumOfLatitudes, SumOfLongitudes As Double
	SumOfLatitudes = 0
	SumOfLongitudes = 0
	Dim Latit, Longit As Double
	Main.LatitudeList.Initialize
	Main.LongitudeList.Initialize
	CursorAverage.Position = 0
	Dim i As Int
	For i = 0 To NumberOfAspects-1
		Latit = CursorAverage.GetDouble("Latitude")
		SumOfLatitudes = SumOfLatitudes + Latit
		Main.LatitudeList.Add(Latit)
		Longit = CursorAverage.GetDouble("Longitude")
		SumOfLongitudes = SumOfLongitudes + Longit
		Main.LongitudeList.Add(Longit)
		If i < NumberOfAspects-1 Then 
			CursorAverage.Position = CursorAverage.Position + 1
		End If
	Next
	Main.CentreLatitude = SumOfLatitudes/NumberOfAspects
	Main.CentreLongitude = SumOfLongitudes/NumberOfAspects
	StartActivity("Map") 'Calls the Map activity.
End Sub

Sub btnView_Click
	StartActivity("View") 'Calls the View activity
End Sub

Sub PopulateCountry
	spnCountry.Clear
	spnCountryId.Clear
	Main.Country = ""
	Main.CountryId = 0
	spnCentre.Clear
	spnCentreId.Clear
	Main.Centre = ""
	Main.CentreId = 0
	spnLocation.Clear
	spnLocationId.Clear
	Main.Location = ""
	Main.LocationId = 0
	Main.Aspect = ""
	Main.AspectId = 0
	Dim query As String
	query = "SELECT Country FROM Country ORDER BY Country"
	PopulateSpinner(spnCountry, "Please Select Country", query)
	' DBUtils.ExecuteSpinner("Please Select Country", Main.SQL1, query, Null, 0, spnCountry)
	If spnCountry.Size < 2 Then
		spnCountry.Clear
		spnCountry.Add("No Country available")
		spnCountry.Prompt = "No Country available"
		spnCountry.Enabled = False
		spnCountryEnabled = False
		DoEvents
		Msgbox("No Country available: Download Database.", _
		       "Empty Database")
		StartActivity("Main") 'Calls the Main activity.
	Else
		query = "SELECT Id FROM Country ORDER BY Country"
		spnCountryId.Clear
		PopulateSpinner(spnCountryId, "0", query)
		' DBUtils.ExecuteSpinner("Country Selected", Main.SQL1, query, Null, 0, spnCountryId)
		spnCountry.Enabled = True
		spnCountryEnabled = True
		DoEvents
		If spnCountry.Size = 2 Then
			spnCountry.SelectedIndex = 1
			spnCountry_ItemClick(1, spnCountry.GetItem(1))
		End If
	End If
End Sub

Sub PopulateCentre
	spnCentre.Clear
	spnCentreId.Clear
	Main.Centre = ""
	Main.CentreId = 0
	spnLocation.Clear
	spnLocationId.Clear
	Main.Location = ""
	Main.LocationId = 0
	Main.Aspect = ""
	Main.AspectId = 0
	Dim query As String
	query = "SELECT Centre FROM Centre " & _
	        "WHERE CountryId = " & Main.CountryId & " " & _
	        "ORDER BY Centre"
	PopulateSpinner(spnCentre, "Please Select Centre", query)
	' DBUtils.ExecuteSpinner("Please Select Centre", Main.SQL1, query, Null, 0, spnCentre)
	If spnCentre.Size < 2 Then
		spnCentre.Clear
		spnCentre.Prompt = "No Centre available"
		spnCentre.Add("No Centre available")
		spnCentre.Enabled = False
		spnCentreEnabled = False
		DoEvents
		Msgbox("No Centre available for Country " & Main.Country & ":" & CRLF & _
		       "Select another Country.", _
		       "Invalid Country")
		Main.Country = ""
		Main.CountryId = 0
		Return
	Else
		query = "SELECT Id FROM Centre " & _
		        "WHERE CountryId = " & Main.CountryId & " " & _
		        "ORDER BY Centre"
		spnCentreId.Clear
		PopulateSpinner(spnCentreId, "0", query)
		' DBUtils.ExecuteSpinner("Centre Selected", Main.SQL1, query, Null, 0, spnCentreId)
		spnCentre.Enabled = True
		spnCentreEnabled = True
		spnCentre.RequestFocus
		DoEvents
		If spnCentre.Size = 2 Then
			spnCentre.SelectedIndex = 1
			spnCentre_ItemClick(1, spnCentre.GetItem(1))
		End If
	End If
End Sub

Sub PopulateLocation
	spnLocation.Clear
	spnLocationId.Clear
	Main.Location = ""
	Main.LocationId = 0
	Main.Aspect = ""
	Main.AspectId = 0
	Dim query As String
	query = "SELECT Location FROM Location " & _ 
	        "WHERE CentreId = " & Main.CentreId & " " & _
	        "ORDER BY Location"
	PopulateSpinner(spnLocation, "Please Select Location", query)
	' DBUtils.ExecuteSpinner("Please Select Location", Main.SQL1, query, Null, 0, spnLocation)
	If spnLocation.Size < 2 Then
			spnLocation.Clear
			spnLocation.Prompt = "No Location available"
			spnLocation.Enabled = False
			spnLocationEnabled = False
			DoEvents
			Msgbox("No Location available for Centre " & Main.Centre & ":" & CRLF & _
			       "Select another Centre.", _
						 "Invalid Centre")
			Main.Centre = ""
			Main.CentreId = 0
			Return
	Else
		query = "SELECT Id FROM Location " & _
		        "WHERE CentreId = " & Main.CentreId & " " & _
		        "ORDER BY Location"
		spnLocationId.Clear
		PopulateSpinner(spnLocationId, "0", query)
		' DBUtils.ExecuteSpinner("Location Selected", Main.SQL1, query, Null, 0, spnLocationId)
		spnLocation.Enabled = True
		spnLocationEnabled = True
		DoEvents
		spnLocation.RequestFocus
		If spnLocation.Size = 2 Then
			spnLocation.SelectedIndex = 1
			spnLocation_ItemClick(1, spnLocation.GetItem(1))
		End If
	End If
End Sub
	
Sub PopulateSpinner(Spinner1 As Spinner, Prompt As String, Query As String)
'Executes the query and fills the Spinner with the values in the first column
  Spinner1.Clear
  Spinner1.Prompt = ""
  Spinner1.Add(Prompt)
  Dim cur As Cursor
  cur = Main.SQL1.ExecQuery(Query)
  Dim row As Int
  For row = 0 To cur.RowCount-1
    cur.Position = row
    Spinner1.Add(cur.GetString2(0))
  Next
  cur.Close
End Sub

Sub ResizeViews
	' Technique below taken from
	' ProbCalc project
	If 100%X < 100%Y Then 
'For Portrait, sets geometry of the views.
lblCountry.SetLayout(3.125%X,2.08333333333333%Y,62.5%X,8.33333333333333%Y)
spnCountryId.SetLayout(65.625%X,2.08333333333333%Y,31.25%X,8.33333333333333%Y)
spnCountry.SetLayout(3.125%X,10.4166666666667%Y,93.75%X,10.4166666666667%Y)
lblCentre.SetLayout(3.125%X,25%Y,62.5%X,8.33333333333333%Y)
spnCentreId.SetLayout(65.625%X,33.3333333333333%Y,31.25%X,8.33333333333333%Y)
spnCentre.SetLayout(3.125%X,33.3333333333333%Y,93.75%X,10.4166666666667%Y)
lblLocation.SetLayout(3.125%X,47.9166666666667%Y,62.5%X,8.33333333333333%Y)
spnLocationId.SetLayout(65.625%X,56.25%Y,31.25%X,8.33333333333333%Y)
spnLocation.SetLayout(3.125%X,56.25%Y,93.75%X,10.4166666666667%Y)
btnMap.SetLayout(3.125%X,77.0833333333333%Y,37.5%X,12.5%Y)
btnView.SetLayout(59.375%X,77.0833333333333%Y,37.5%X,12.5%Y)
	Else
'For Landscape, sets geometry of the views.
lblCountry.SetLayout(2.08333333333333%X,3.125%Y,41.6666666666667%X,9.375%Y)
spnCountryId.SetLayout(43.75%X,3.125%Y,20.8333333333333%X,9.375%Y)
spnCountry.SetLayout(2.08333333333333%X,12.5%Y,62.5%X,15.625%Y)
lblCentre.SetLayout(2.08333333333333%X,34.375%Y,41.6666666666667%X,9.375%Y)
spnCentreId.SetLayout(33.3333333333333%X,34.375%Y,20.8333333333333%X,9.375%Y)
spnCentre.SetLayout(2.08333333333333%X,43.75%Y,62.5%X,15.625%Y)
lblLocation.SetLayout(2.08333333333333%X,65.625%Y,41.6666666666667%X,9.375%Y)
spnLocationId.SetLayout(33.3333333333333%X,65.625%Y,20.8333333333333%X,9.375%Y)
spnLocation.SetLayout(2.08333333333333%X,75%Y,62.5%X,15.625%Y)
btnMap.SetLayout(72.9166666666667%X,34.375%Y,25%X,25%Y)
btnView.SetLayout(72.9166666666667%X,65.625%Y,25%X,25%Y)
  End If
End Sub
