﻿Type=Activity
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

'Information Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private InformationHeight As Int
	Private scvInformationScrollPosition As Int
	scvInformationScrollPosition = 0
	Private StrUtil As StringUtils
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim scvInformation As ScrollView
	Dim lblInformation As Label
	lblInformation.Initialize("")
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Information") 'Load the Information layout file.
	scvInformation.SetLayout(0, 0, 100%x, 100%y)
	scvInformation.Panel.AddView(lblInformation, _
	                             0, _
								 0, _
								 scvInformation.Width, _
								 scvInformation.Height)
	lblInformation.Color = Colors.Black
	lblInformation.TextColor = Colors.White
	lblInformation.Text = Main.InformationText
	InformationHeight = StrUtil.MeasureMultilineTextHeight(lblInformation, Main.InformationText)
	' set the ScrollView internal Panel height to the measured height
    scvInformation.Panel.Height = InformationHeight
	' set the Label height to the measured height
    lblInformation.Height = InformationHeight 
    ' set the scroll position to the top of the text
	scvInformation.ScrollPosition = lblInformation.Top 
    DoEvents ' needed to execute the previous lines
End Sub

Sub Activity_Resume
	scvInformation.SetLayout(0, 0, 100%x, 100%y)
	lblInformation.Width = scvInformation.Width
	InformationHeight = StrUtil.MeasureMultilineTextHeight(lblInformation, lblInformation.Text)
	lblInformation.Height = InformationHeight
	scvInformation.Panel.Width = scvInformation.Width
	scvInformation.Panel.Height = InformationHeight
	scvInformation.ScrollPosition = scvInformationScrollPosition
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	scvInformationScrollPosition = scvInformation.ScrollPosition
End Sub



