﻿Type=Activity
Version=5.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

'Photo Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private pnlPhotoLeft As Int
	pnlPhotoLeft = 0
	Private pnlPhotoTop As Int
	pnlPhotoTop = 0
	Private CurrentPhotoLeft As Int
	CurrentPhotoLeft = 0
	Private CurrentPhotoTop As Int
	CurrentPhotoTop = 0
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim pnlPhoto As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	' This technique taken from ScrollImage
	Activity.LoadLayout("Photo")  ' Load the Photo layout file
	pnlPhoto.SetLayout(0, 0, 100%x, 100%y)
	pnlPhoto.Width = Main.PhotoBitmap.Width
	pnlPhoto.Height = Main.PhotoBitmap.Height
	pnlPhoto.SetBackgroundImage(Main.PhotoBitmap)
End Sub

Sub Activity_Resume
  pnlPhoto.SetLayout(0, 0, 100%x, 100%y)
	pnlPhoto.Left = pnlPhotoLeft
	pnlPhoto.Top = pnlPhotoTop
	pnlPhoto.Width = Main.PhotoBitmap.Width
	pnlPhoto.Height = Main.PhotoBitmap.Height
	pnlPhoto.SetBackgroundImage(Main.PhotoBitmap)
	DoEvents
End Sub

Sub Activity_Pause (UserClosed As Boolean)
  pnlPhotoLeft = pnlPhoto.Left
	pnlPhotoTop = pnlPhoto.Top
End Sub

Sub Activity_Touch(Action As Int, X As Float, Y As Float)
	' copied from ScrollImage project
	Dim TempLeft, TempTop As Int
	Select Action
		Case Activity.ACTION_DOWN
			pnlPhotoLeft = pnlPhoto.Left		' saves the current Left value
			pnlPhotoTop = pnlPhoto.Top			' saves the current Top value
			CurrentPhotoLeft = X								' saves the current X value
			CurrentPhotoTop = Y								' saves the current Y value
		Case Activity.ACTION_MOVE
			TempLeft = pnlPhotoLeft + X - CurrentPhotoLeft			' calculates the new Left value
			TempLeft = Min(TempLeft, 0)				' checks the highest value
			TempLeft = Max(TempLeft, -pnlPhoto.Width+Activity.Width)	' checks the lowest value
			pnlPhotoLeft = TempLeft	' sets the Left new value
			pnlPhoto.Left = pnlPhotoLeft
			TempTop = pnlPhotoTop + Y - CurrentPhotoTop			' calculates the new Top value
			TempTop = Min(TempTop, 0)				' checks the highest value
			TempTop = Max(TempTop, -pnlPhoto.Height+Activity.Height) ' checks the lowest value
			pnlPhotoTop = TempTop			' sets the Top new value
			pnlPhoto.Top = pnlPhotoTop
			DoEvents
	End Select
End Sub


